/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.java.net
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.integritychecker.impl;

import org.openide.util.Exceptions;
import org.openide.modules.ModuleInstall;
import it.tidalwave.actor.spi.ActorActivator;
import lombok.extern.slf4j.Slf4j;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Slf4j
public class Installer extends ModuleInstall 
  {
    private ActorActivator a1;
    private ActorActivator a2;
    private ActorActivator a3;
    private ActorActivator a4;
            
    @Override
    public void restored() 
      {
        try 
          {
            a1 = new ActorActivator(FileObjectDiscoveryActor.class, 8);
            a2 = new ActorActivator(FileLoaderActor.class, 1);
            a3 = new ActorActivator(FingerprintComputerActor.class, 4);
            a4 = new ActorActivator(PersistenceManagerActor.class, 1);
            
            a1.initialize();
            a2.initialize();
            a3.initialize();
            a4.initialize();
            
            log.info("Activated actors");
          }
        catch (InstantiationException e) 
          {
            Exceptions.printStackTrace(e);
          }
        catch (IllegalAccessException e) 
          {
            Exceptions.printStackTrace(e);
          }
      }

    @Override
    public void close() 
      {
        super.close();
        // TODO: deactivate actors
      }
  }
